---
layout: page
title: MXNet Community Guideline
subtitle: How MXNet community operates
action: Contribute
action_url: /community/index
permalink: /community/community
---
<!--- Licensed to the Apache Software Foundation (ASF) under one -->
<!--- or more contributor license agreements.  See the NOTICE file -->
<!--- distributed with this work for additional information -->
<!--- regarding copyright ownership.  The ASF licenses this file -->
<!--- to you under the Apache License, Version 2.0 (the -->
<!--- "License"); you may not use this file except in compliance -->
<!--- with the License.  You may obtain a copy of the License at -->

<!---   http://www.apache.org/licenses/LICENSE-2.0 -->

<!--- Unless required by applicable law or agreed to in writing, -->
<!--- software distributed under the License is distributed on an -->
<!--- "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY -->
<!--- KIND, either express or implied.  See the License for the -->
<!--- specific language governing permissions and limitations -->
<!--- under the License. -->

MXNet Community Guideline
=========================

Apache MXNet follows the [Apache Way](https://www.apache.org/theapacheway/) governs by merit.
We believe that
it is important to create an inclusive community where everyone can use,
contribute to, and influence the direction of the project. See
[CONTRIBUTORS.md](https://github.com/apache/incubator-mxnet/blob/master/CONTRIBUTORS.md)
for the current list of contributors.

General Development Process
---------------------------

Everyone in the community is welcome to send patches, documents, and
propose new directions to the project. The key guideline here is to
enable everyone in the community to get involved and participate the
decision and development. When major changes are proposed, an RFC should
be sent to allow discussion by the community. We encourage public
discussion, archivable channels such as issues, discuss forum and
mailing-list, so that everyone in the community can participate and
review the process later.

Code reviews are one of the key ways to ensure the quality of the code.
High-quality code reviews prevent technical debt for long-term and are
crucial to the success of the project. A pull request needs to be
reviewed before it gets merged. A committer who has the expertise of the
corresponding area would moderate the pull request and the merge the
code when it is ready. The corresponding committer could request
multiple reviewers who are familiar with the area of the code. We
encourage contributors to request code reviews themselves and help
review each other's code \-\- remember everyone is volunteering their
time to the community, high-quality code review itself costs as much as
the actual code contribution, you could get your code quickly reviewed
if you do others the same favor.

The community should strive to reach a consensus on technical decisions
through discussion. We expect committers and PMCs to moderate technical
discussions in a diplomatic way, and provide suggestions with clear
technical reasoning when necessary.

Committers
----------

Committers are individuals who are granted the write access to the
project. A committer is usually responsible for a certain area or
several areas of the code where they oversee the code review process.
The area of contribution can take all forms, including code
contributions and code reviews, documents, education, and outreach.
Committers are essential for a high quality and healthy project. The
community actively look for new committers from contributors. Here is a
list of useful traits that help the community to recognize potential
committers:

-   Sustained contribution to the project, demonstrated by discussion
    over RFCs, code reviews and proposals of new features, and other
    development activities. Being familiar with, and being able to take
    ownership on one or several areas of the project.
-   Quality of contributions: High-quality, readable code contributions
    indicated by pull requests that can be merged without a substantial
    code review. History of creating clean, maintainable code and
    including good test cases. Informative code reviews to help other
    contributors that adhere to a good standard.
-   Community involvement: active participation in the discussion forum,
    promote the projects via tutorials, talks and outreach. We encourage
    committers to collaborate broadly, e.g. do code reviews and discuss
    designs with community members that they do not interact physically.

The Project Management Committee(PMC) consists group of active
committers that moderate the discussion, manage the project release, and
proposes new committer/PMC members. Potential candidates are usually
proposed via an internal discussion among PMCs, followed by a consensus
approval, i.e. least 3 +1 votes, and no vetoes. Any veto must be
accompanied by reasoning. PMCs should serve the community by upholding
the community practices and guidelines and make MXNet a better community for
everyone. PMCs should strive to only nominate new candidates outside of
their own organization.

Reviewers
---------

Reviewers are individuals who actively contributed to the project and
are willing to participate in the code review of new contributions. We
identify reviewers from active contributors. The committers should
explicitly solicit reviews from reviewers. High-quality code reviews
prevent technical debt for long-term and are crucial to the success of
the project. A pull request to the project has to be reviewed by at
least one reviewer in order to be merged.

<script async defer src="https://buttons.github.io/buttons.js"></script>
<script src="https://apis.google.com/js/platform.js"></script>
